Index: ui/mainwindow.ui
===================================================================
--- ui/mainwindow.ui	(revision e2abfd326fbc0376081d9298a0ae92600057d629)
+++ ui/mainwindow.ui	(revision b574c383b7908655a2d893f213a82f3f46c316d4)
@@ -182,4 +182,7 @@
 	   <property name="statusTip">
 		<string>Solution steps</string>
+	   </property>
+	   <property name="undoRedoEnabled">
+		<bool>false</bool>
 	   </property>
 	   <property name="readOnly">
Index: ui/settingsdialog.ui
===================================================================
--- ui/settingsdialog.ui	(revision e2abfd326fbc0376081d9298a0ae92600057d629)
+++ ui/settingsdialog.ui	(revision b574c383b7908655a2d893f213a82f3f46c316d4)
@@ -9,522 +9,448 @@
   <property name="windowIcon">
    <iconset resource="../resources/tspsg.qrc">
-    <normaloff>:/images/icons/preferences_system.png</normaloff>:/images/icons/preferences_system.png</iconset>
+	<normaloff>:/images/icons/preferences_system.png</normaloff>:/images/icons/preferences_system.png</iconset>
   </property>
   <widget class="QWidget" name="bgGrey" native="true">
    <property name="sizePolicy">
-    <sizepolicy hsizetype="Preferred" vsizetype="Fixed">
-     <horstretch>0</horstretch>
-     <verstretch>0</verstretch>
-    </sizepolicy>
-   </property>
-   <property name="palette">
-    <palette>
-     <active>
-      <colorrole role="Window">
-       <brush brushstyle="SolidPattern">
-        <color alpha="255">
-         <red>240</red>
-         <green>240</green>
-         <blue>240</blue>
-        </color>
-       </brush>
-      </colorrole>
-     </active>
-     <inactive>
-      <colorrole role="Window">
-       <brush brushstyle="SolidPattern">
-        <color alpha="255">
-         <red>240</red>
-         <green>240</green>
-         <blue>240</blue>
-        </color>
-       </brush>
-      </colorrole>
-     </inactive>
-     <disabled>
-      <colorrole role="Window">
-       <brush brushstyle="SolidPattern">
-        <color alpha="255">
-         <red>240</red>
-         <green>240</green>
-         <blue>240</blue>
-        </color>
-       </brush>
-      </colorrole>
-     </disabled>
-    </palette>
+	<sizepolicy hsizetype="Preferred" vsizetype="Fixed">
+	 <horstretch>0</horstretch>
+	 <verstretch>0</verstretch>
+	</sizepolicy>
    </property>
    <property name="autoFillBackground">
-    <bool>true</bool>
+	<bool>true</bool>
    </property>
    <layout class="QVBoxLayout" name="_2">
-    <property name="spacing">
-     <number>0</number>
-    </property>
-    <property name="margin">
-     <number>0</number>
-    </property>
-    <item>
-     <widget class="Line" name="lineHorizontal">
-      <property name="maximumSize">
-       <size>
-        <width>16777215</width>
-        <height>2</height>
-       </size>
-      </property>
-      <property name="frameShadow">
-       <enum>QFrame::Plain</enum>
-      </property>
-      <property name="lineWidth">
-       <number>2</number>
-      </property>
-      <property name="orientation">
-       <enum>Qt::Horizontal</enum>
-      </property>
-     </widget>
-    </item>
-    <item>
-     <layout class="QHBoxLayout" name="buttons">
-      <property name="spacing">
-       <number>6</number>
-      </property>
-      <property name="margin">
-       <number>6</number>
-      </property>
-      <item>
-       <widget class="QToolButton" name="buttonHelp">
-        <property name="enabled">
-         <bool>false</bool>
-        </property>
-        <property name="cursor">
-         <cursorShape>PointingHandCursor</cursorShape>
-        </property>
-        <property name="toolTip">
-         <string>Help</string>
-        </property>
-        <property name="statusTip">
-         <string>Get preferences help</string>
-        </property>
-        <property name="text">
-         <string>Help</string>
-        </property>
-        <property name="icon">
-         <iconset resource="../resources/tspsg.qrc">
-          <normaloff>:/images/icons/help_hint.png</normaloff>:/images/icons/help_hint.png</iconset>
-        </property>
-        <property name="autoRaise">
-         <bool>true</bool>
-        </property>
-       </widget>
-      </item>
-      <item>
-       <widget class="QDialogButtonBox" name="buttonBox">
-        <property name="standardButtons">
-         <set>QDialogButtonBox::Cancel|QDialogButtonBox::Save</set>
-        </property>
-       </widget>
-      </item>
-     </layout>
-    </item>
+	<property name="spacing">
+	 <number>0</number>
+	</property>
+	<property name="margin">
+	 <number>0</number>
+	</property>
+	<item>
+	 <widget class="Line" name="lineHorizontal">
+	  <property name="maximumSize">
+	   <size>
+		<width>16777215</width>
+		<height>2</height>
+	   </size>
+	  </property>
+	  <property name="frameShadow">
+	   <enum>QFrame::Plain</enum>
+	  </property>
+	  <property name="lineWidth">
+	   <number>2</number>
+	  </property>
+	  <property name="orientation">
+	   <enum>Qt::Horizontal</enum>
+	  </property>
+	 </widget>
+	</item>
+	<item>
+	 <layout class="QHBoxLayout" name="buttons">
+	  <property name="spacing">
+	   <number>6</number>
+	  </property>
+	  <property name="margin">
+	   <number>6</number>
+	  </property>
+	  <item>
+	   <widget class="QToolButton" name="buttonHelp">
+		<property name="enabled">
+		 <bool>false</bool>
+		</property>
+		<property name="cursor">
+		 <cursorShape>PointingHandCursor</cursorShape>
+		</property>
+		<property name="toolTip">
+		 <string>Help</string>
+		</property>
+		<property name="statusTip">
+		 <string>Get preferences help</string>
+		</property>
+		<property name="text">
+		 <string>Help</string>
+		</property>
+		<property name="icon">
+		 <iconset resource="../resources/tspsg.qrc">
+		  <normaloff>:/images/icons/help_hint.png</normaloff>:/images/icons/help_hint.png</iconset>
+		</property>
+		<property name="autoRaise">
+		 <bool>true</bool>
+		</property>
+	   </widget>
+	  </item>
+	  <item>
+	   <widget class="QDialogButtonBox" name="buttonBox">
+		<property name="standardButtons">
+		 <set>QDialogButtonBox::Cancel|QDialogButtonBox::Save</set>
+		</property>
+	   </widget>
+	  </item>
+	 </layout>
+	</item>
    </layout>
   </widget>
   <widget class="QWidget" name="bgWhite" native="true">
-   <property name="palette">
-    <palette>
-     <active>
-      <colorrole role="Window">
-       <brush brushstyle="SolidPattern">
-        <color alpha="255">
-         <red>255</red>
-         <green>255</green>
-         <blue>255</blue>
-        </color>
-       </brush>
-      </colorrole>
-     </active>
-     <inactive>
-      <colorrole role="Window">
-       <brush brushstyle="SolidPattern">
-        <color alpha="255">
-         <red>255</red>
-         <green>255</green>
-         <blue>255</blue>
-        </color>
-       </brush>
-      </colorrole>
-     </inactive>
-     <disabled>
-      <colorrole role="Window">
-       <brush brushstyle="SolidPattern">
-        <color alpha="255">
-         <red>255</red>
-         <green>255</green>
-         <blue>255</blue>
-        </color>
-       </brush>
-      </colorrole>
-     </disabled>
-    </palette>
-   </property>
    <property name="autoFillBackground">
-    <bool>true</bool>
+	<bool>true</bool>
    </property>
    <layout class="QHBoxLayout" name="_3">
-    <item>
-     <widget class="QTabWidget" name="tabWidget">
-      <widget class="QWidget" name="tabGeneral">
-       <attribute name="title">
-        <string>General</string>
-       </attribute>
-       <attribute name="toolTip">
-        <string>General TSPSG settings</string>
-       </attribute>
-       <layout class="QVBoxLayout" name="_4">
-        <item>
-         <widget class="QCheckBox" name="cbAutosize">
-          <property name="cursor">
-           <cursorShape>PointingHandCursor</cursorShape>
-          </property>
-          <property name="statusTip">
-           <string>Automatically resize rows and columns to their contents</string>
-          </property>
-          <property name="text">
-           <string>Autosize of rows and columns</string>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <widget class="QCheckBox" name="cbUseNativeDialogs">
-          <property name="cursor">
-           <cursorShape>PointingHandCursor</cursorShape>
-          </property>
-          <property name="statusTip">
-           <string>Use native File Open and File Save dialogs (uncheck to use Qt's Dialogs)</string>
-          </property>
-          <property name="text">
-           <string>Use native file dialogs</string>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <spacer name="spacer">
-          <property name="orientation">
-           <enum>Qt::Vertical</enum>
-          </property>
-          <property name="sizeHint" stdset="0">
-           <size>
-            <width>0</width>
-            <height>0</height>
-           </size>
-          </property>
-         </spacer>
-        </item>
-       </layout>
-      </widget>
-      <widget class="QWidget" name="tabTask">
-       <attribute name="title">
-        <string>Task</string>
-       </attribute>
-       <attribute name="toolTip">
-        <string>Task generation and solving settings</string>
-       </attribute>
-       <layout class="QVBoxLayout" name="_9">
-        <item>
-         <layout class="QFormLayout" name="_5">
-          <property name="fieldGrowthPolicy">
-           <enum>QFormLayout::ExpandingFieldsGrow</enum>
-          </property>
-          <item row="0" column="0">
-           <widget class="QLabel" name="labelFractionalAccuracy">
-            <property name="text">
-             <string>Fractional accuracy:</string>
-            </property>
-           </widget>
-          </item>
-          <item row="0" column="1">
-           <widget class="QSpinBox" name="spinFractionalAccuracy">
-            <property name="cursor">
-             <cursorShape>PointingHandCursor</cursorShape>
-            </property>
-            <property name="statusTip">
-             <string>Accuracy of the fractional values (in decimal places)</string>
-            </property>
-            <property name="maximum">
-             <number>6</number>
-            </property>
-           </widget>
-          </item>
-         </layout>
-        </item>
-        <item>
-         <widget class="QCheckBox" name="cbSymmetricMode">
-          <property name="cursor">
-           <cursorShape>PointingHandCursor</cursorShape>
-          </property>
-          <property name="statusTip">
-           <string>In this mode the cost of travel from city 1 to city 2 and vice versa is the same</string>
-          </property>
-          <property name="text">
-           <string>Symmetric mode</string>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <widget class="QGroupBox" name="gbTaskGeneration">
-          <property name="title">
-           <string>Task generation</string>
-          </property>
-          <layout class="QVBoxLayout" name="_7">
-           <item>
-            <layout class="QFormLayout" name="_8">
-             <property name="fieldGrowthPolicy">
-              <enum>QFormLayout::ExpandingFieldsGrow</enum>
-             </property>
-             <item row="0" column="0">
-              <widget class="QLabel" name="labelRandMin">
-               <property name="text">
-                <string>Minimal random:</string>
-               </property>
-               <property name="buddy">
-                <cstring>spinRandMin</cstring>
-               </property>
-              </widget>
-             </item>
-             <item row="0" column="1">
-              <widget class="QSpinBox" name="spinRandMin">
-               <property name="cursor">
-                <cursorShape>PointingHandCursor</cursorShape>
-               </property>
-               <property name="statusTip">
-                <string>Minimum for random number generation</string>
-               </property>
-              </widget>
-             </item>
-             <item row="1" column="0">
-              <widget class="QLabel" name="labelRandMax">
-               <property name="text">
-                <string>Maximal random:</string>
-               </property>
-               <property name="buddy">
-                <cstring>spinRandMax</cstring>
-               </property>
-              </widget>
-             </item>
-             <item row="1" column="1">
-              <widget class="QSpinBox" name="spinRandMax">
-               <property name="cursor">
-                <cursorShape>PointingHandCursor</cursorShape>
-               </property>
-               <property name="statusTip">
-                <string>Maximum for random number generation</string>
-               </property>
-              </widget>
-             </item>
-            </layout>
-           </item>
-           <item>
-            <widget class="QCheckBox" name="cbFractionalRandom">
-             <property name="cursor">
-              <cursorShape>PointingHandCursor</cursorShape>
-             </property>
-             <property name="statusTip">
-              <string>Generate fractional random values with the Fractional accuracy</string>
-             </property>
-             <property name="text">
-              <string>Fractional random values</string>
-             </property>
-            </widget>
-           </item>
-          </layout>
-         </widget>
-        </item>
-        <item>
-         <spacer name="spacer_2">
-          <property name="orientation">
-           <enum>Qt::Vertical</enum>
-          </property>
-          <property name="sizeHint" stdset="0">
-           <size>
-            <width>10</width>
-            <height>0</height>
-           </size>
-          </property>
-         </spacer>
-        </item>
-       </layout>
-      </widget>
-      <widget class="QWidget" name="tabOutput">
-       <attribute name="title">
-        <string>Output</string>
-       </attribute>
-       <attribute name="toolTip">
-        <string>Solution output settings</string>
-       </attribute>
-       <layout class="QVBoxLayout" name="_6">
-        <item>
-         <widget class="QCheckBox" name="cbShowMatrix">
-          <property name="cursor">
-           <cursorShape>PointingHandCursor</cursorShape>
-          </property>
-          <property name="statusTip">
-           <string>Show solution steps' matrices for every solution step</string>
-          </property>
-          <property name="text">
-           <string>Show solution steps' matrices</string>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <layout class="QHBoxLayout" name="layoutCititesLimit">
-          <property name="spacing">
-           <number>0</number>
-          </property>
-          <item>
-           <spacer name="spacer_3">
-            <property name="orientation">
-             <enum>Qt::Horizontal</enum>
-            </property>
-            <property name="sizeType">
-             <enum>QSizePolicy::Fixed</enum>
-            </property>
-            <property name="sizeHint" stdset="0">
-             <size>
-              <width>10</width>
-              <height>0</height>
-             </size>
-            </property>
-           </spacer>
-          </item>
-          <item>
-           <widget class="QCheckBox" name="cbCitiesLimit">
-            <property name="cursor">
-             <cursorShape>PointingHandCursor</cursorShape>
-            </property>
-            <property name="statusTip">
-             <string>Show or hide solution steps' matrices based on number of cities in the task</string>
-            </property>
-            <property name="text">
-             <string>Only when &lt;=</string>
-            </property>
-           </widget>
-          </item>
-          <item>
-           <widget class="QSpinBox" name="spinCitiesLimit">
-            <property name="statusTip">
-             <string>Maximum number of cities to show solution steps' matrices</string>
-            </property>
-            <property name="suffix">
-             <string comment="Don't forget a space at the beginning!"> cities</string>
-            </property>
-            <property name="minimum">
-             <number>1</number>
-            </property>
-           </widget>
-          </item>
-          <item>
-           <spacer name="spacer_4">
-            <property name="orientation">
-             <enum>Qt::Horizontal</enum>
-            </property>
-            <property name="sizeHint" stdset="0">
-             <size>
-              <width>0</width>
-              <height>0</height>
-             </size>
-            </property>
-           </spacer>
-          </item>
-         </layout>
-        </item>
-        <item>
-         <widget class="QCheckBox" name="cbScrollToEnd">
-          <property name="cursor">
-           <cursorShape>PointingHandCursor</cursorShape>
-          </property>
-          <property name="statusTip">
-           <string>Scroll to the end of solution output after solving</string>
-          </property>
-          <property name="text">
-           <string>Scroll to solution end</string>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <layout class="QHBoxLayout" name="_11">
-          <item>
-           <widget class="QGroupBox" name="groupOutput">
-            <property name="title">
-             <string>Output font settings</string>
-            </property>
-            <layout class="QHBoxLayout" name="_13">
-             <item>
-              <widget class="QPushButton" name="buttonFont">
-               <property name="cursor">
-                <cursorShape>PointingHandCursor</cursorShape>
-               </property>
-               <property name="statusTip">
-                <string>Font face for solution output</string>
-               </property>
-               <property name="text">
-                <string>&amp;Font...</string>
-               </property>
-               <property name="icon">
-                <iconset resource="../resources/tspsg.qrc">
-                 <normaloff>:/images/icons/fonts.png</normaloff>:/images/icons/fonts.png</iconset>
-               </property>
-              </widget>
-             </item>
-             <item>
-              <widget class="QPushButton" name="buttonColor">
-               <property name="cursor">
-                <cursorShape>PointingHandCursor</cursorShape>
-               </property>
-               <property name="statusTip">
-                <string>Font color for solution output</string>
-               </property>
-               <property name="text">
-                <string>&amp;Color...</string>
-               </property>
-               <property name="icon">
-                <iconset resource="../resources/tspsg.qrc">
-                 <normaloff>:/images/icons/color_line.png</normaloff>:/images/icons/color_line.png</iconset>
-               </property>
-              </widget>
-             </item>
-             <item>
-              <spacer name="spacer_5">
-               <property name="orientation">
-                <enum>Qt::Horizontal</enum>
-               </property>
-               <property name="sizeHint" stdset="0">
-                <size>
-                 <width>0</width>
-                 <height>0</height>
-                </size>
-               </property>
-              </spacer>
-             </item>
-            </layout>
-           </widget>
-          </item>
-         </layout>
-        </item>
-        <item>
-         <spacer name="spacer_6">
-          <property name="orientation">
-           <enum>Qt::Vertical</enum>
-          </property>
-          <property name="sizeHint" stdset="0">
-           <size>
-            <width>0</width>
-            <height>0</height>
-           </size>
-          </property>
-         </spacer>
-        </item>
-       </layout>
-      </widget>
-     </widget>
-    </item>
+	<item>
+	 <widget class="QTabWidget" name="tabWidget">
+	  <widget class="QWidget" name="tabGeneral">
+	   <attribute name="title">
+		<string>General</string>
+	   </attribute>
+	   <attribute name="toolTip">
+		<string>General TSPSG settings</string>
+	   </attribute>
+	   <layout class="QVBoxLayout" name="_4">
+		<item>
+		 <widget class="QCheckBox" name="cbAutosize">
+		  <property name="cursor">
+		   <cursorShape>PointingHandCursor</cursorShape>
+		  </property>
+		  <property name="statusTip">
+		   <string>Automatically resize rows and columns to their contents</string>
+		  </property>
+		  <property name="text">
+		   <string>Autosize of rows and columns</string>
+		  </property>
+		 </widget>
+		</item>
+		<item>
+		 <widget class="QCheckBox" name="cbUseNativeDialogs">
+		  <property name="cursor">
+		   <cursorShape>PointingHandCursor</cursorShape>
+		  </property>
+		  <property name="statusTip">
+		   <string>Use native File Open and File Save dialogs (uncheck to use Qt's Dialogs)</string>
+		  </property>
+		  <property name="text">
+		   <string>Use native file dialogs</string>
+		  </property>
+		 </widget>
+		</item>
+		<item>
+		 <spacer name="spacer">
+		  <property name="orientation">
+		   <enum>Qt::Vertical</enum>
+		  </property>
+		  <property name="sizeHint" stdset="0">
+		   <size>
+			<width>0</width>
+			<height>0</height>
+		   </size>
+		  </property>
+		 </spacer>
+		</item>
+	   </layout>
+	  </widget>
+	  <widget class="QWidget" name="tabTask">
+	   <attribute name="title">
+		<string>Task</string>
+	   </attribute>
+	   <attribute name="toolTip">
+		<string>Task generation and solving settings</string>
+	   </attribute>
+	   <layout class="QVBoxLayout" name="_9">
+		<item>
+		 <layout class="QFormLayout" name="_5">
+		  <property name="fieldGrowthPolicy">
+		   <enum>QFormLayout::ExpandingFieldsGrow</enum>
+		  </property>
+		  <item row="0" column="0">
+		   <widget class="QLabel" name="labelFractionalAccuracy">
+			<property name="text">
+			 <string>Fractional accuracy:</string>
+			</property>
+		   </widget>
+		  </item>
+		  <item row="0" column="1">
+		   <widget class="QSpinBox" name="spinFractionalAccuracy">
+			<property name="cursor">
+			 <cursorShape>PointingHandCursor</cursorShape>
+			</property>
+			<property name="statusTip">
+			 <string>Accuracy of the fractional values (in decimal places)</string>
+			</property>
+			<property name="maximum">
+			 <number>6</number>
+			</property>
+		   </widget>
+		  </item>
+		 </layout>
+		</item>
+		<item>
+		 <widget class="QCheckBox" name="cbSymmetricMode">
+		  <property name="cursor">
+		   <cursorShape>PointingHandCursor</cursorShape>
+		  </property>
+		  <property name="statusTip">
+		   <string>In this mode the cost of travel from city 1 to city 2 and vice versa is the same</string>
+		  </property>
+		  <property name="text">
+		   <string>Symmetric mode</string>
+		  </property>
+		 </widget>
+		</item>
+		<item>
+		 <widget class="QGroupBox" name="gbTaskGeneration">
+		  <property name="title">
+		   <string>Task generation</string>
+		  </property>
+		  <layout class="QVBoxLayout" name="_7">
+		   <item>
+			<layout class="QFormLayout" name="_8">
+			 <property name="fieldGrowthPolicy">
+			  <enum>QFormLayout::ExpandingFieldsGrow</enum>
+			 </property>
+			 <item row="0" column="0">
+			  <widget class="QLabel" name="labelRandMin">
+			   <property name="text">
+				<string>Minimal random:</string>
+			   </property>
+			   <property name="buddy">
+				<cstring>spinRandMin</cstring>
+			   </property>
+			  </widget>
+			 </item>
+			 <item row="0" column="1">
+			  <widget class="QSpinBox" name="spinRandMin">
+			   <property name="cursor">
+				<cursorShape>PointingHandCursor</cursorShape>
+			   </property>
+			   <property name="statusTip">
+				<string>Minimum for random number generation</string>
+			   </property>
+			  </widget>
+			 </item>
+			 <item row="1" column="0">
+			  <widget class="QLabel" name="labelRandMax">
+			   <property name="text">
+				<string>Maximal random:</string>
+			   </property>
+			   <property name="buddy">
+				<cstring>spinRandMax</cstring>
+			   </property>
+			  </widget>
+			 </item>
+			 <item row="1" column="1">
+			  <widget class="QSpinBox" name="spinRandMax">
+			   <property name="cursor">
+				<cursorShape>PointingHandCursor</cursorShape>
+			   </property>
+			   <property name="statusTip">
+				<string>Maximum for random number generation</string>
+			   </property>
+			  </widget>
+			 </item>
+			</layout>
+		   </item>
+		   <item>
+			<widget class="QCheckBox" name="cbFractionalRandom">
+			 <property name="cursor">
+			  <cursorShape>PointingHandCursor</cursorShape>
+			 </property>
+			 <property name="statusTip">
+			  <string>Generate fractional random values with the Fractional accuracy</string>
+			 </property>
+			 <property name="text">
+			  <string>Fractional random values</string>
+			 </property>
+			</widget>
+		   </item>
+		  </layout>
+		 </widget>
+		</item>
+		<item>
+		 <spacer name="spacer_2">
+		  <property name="orientation">
+		   <enum>Qt::Vertical</enum>
+		  </property>
+		  <property name="sizeHint" stdset="0">
+		   <size>
+			<width>10</width>
+			<height>0</height>
+		   </size>
+		  </property>
+		 </spacer>
+		</item>
+	   </layout>
+	  </widget>
+	  <widget class="QWidget" name="tabOutput">
+	   <attribute name="title">
+		<string>Output</string>
+	   </attribute>
+	   <attribute name="toolTip">
+		<string>Solution output settings</string>
+	   </attribute>
+	   <layout class="QVBoxLayout" name="_6">
+		<item>
+		 <widget class="QCheckBox" name="cbShowMatrix">
+		  <property name="cursor">
+		   <cursorShape>PointingHandCursor</cursorShape>
+		  </property>
+		  <property name="statusTip">
+		   <string>Show solution steps' matrices for every solution step</string>
+		  </property>
+		  <property name="text">
+		   <string>Show solution steps' matrices</string>
+		  </property>
+		 </widget>
+		</item>
+		<item>
+		 <layout class="QHBoxLayout" name="layoutCititesLimit">
+		  <property name="spacing">
+		   <number>0</number>
+		  </property>
+		  <item>
+		   <spacer name="spacer_3">
+			<property name="orientation">
+			 <enum>Qt::Horizontal</enum>
+			</property>
+			<property name="sizeType">
+			 <enum>QSizePolicy::Fixed</enum>
+			</property>
+			<property name="sizeHint" stdset="0">
+			 <size>
+			  <width>10</width>
+			  <height>0</height>
+			 </size>
+			</property>
+		   </spacer>
+		  </item>
+		  <item>
+		   <widget class="QCheckBox" name="cbCitiesLimit">
+			<property name="cursor">
+			 <cursorShape>PointingHandCursor</cursorShape>
+			</property>
+			<property name="statusTip">
+			 <string>Show or hide solution steps' matrices based on number of cities in the task</string>
+			</property>
+			<property name="text">
+			 <string>Only when &lt;=</string>
+			</property>
+		   </widget>
+		  </item>
+		  <item>
+		   <widget class="QSpinBox" name="spinCitiesLimit">
+			<property name="statusTip">
+			 <string>Maximum number of cities to show solution steps' matrices</string>
+			</property>
+			<property name="suffix">
+			 <string comment="Don't forget a space at the beginning!"> cities</string>
+			</property>
+			<property name="minimum">
+			 <number>1</number>
+			</property>
+		   </widget>
+		  </item>
+		  <item>
+		   <spacer name="spacer_4">
+			<property name="orientation">
+			 <enum>Qt::Horizontal</enum>
+			</property>
+			<property name="sizeHint" stdset="0">
+			 <size>
+			  <width>0</width>
+			  <height>0</height>
+			 </size>
+			</property>
+		   </spacer>
+		  </item>
+		 </layout>
+		</item>
+		<item>
+		 <widget class="QCheckBox" name="cbScrollToEnd">
+		  <property name="cursor">
+		   <cursorShape>PointingHandCursor</cursorShape>
+		  </property>
+		  <property name="statusTip">
+		   <string>Scroll to the end of solution output after solving</string>
+		  </property>
+		  <property name="text">
+		   <string>Scroll to solution end</string>
+		  </property>
+		 </widget>
+		</item>
+		<item>
+		 <layout class="QHBoxLayout" name="_11">
+		  <item>
+		   <widget class="QGroupBox" name="groupOutput">
+			<property name="title">
+			 <string>Output font settings</string>
+			</property>
+			<layout class="QHBoxLayout" name="_13">
+			 <item>
+			  <widget class="QPushButton" name="buttonFont">
+			   <property name="cursor">
+				<cursorShape>PointingHandCursor</cursorShape>
+			   </property>
+			   <property name="statusTip">
+				<string>Font face for solution output</string>
+			   </property>
+			   <property name="text">
+				<string>&amp;Font...</string>
+			   </property>
+			   <property name="icon">
+				<iconset resource="../resources/tspsg.qrc">
+				 <normaloff>:/images/icons/fonts.png</normaloff>:/images/icons/fonts.png</iconset>
+			   </property>
+			  </widget>
+			 </item>
+			 <item>
+			  <widget class="QPushButton" name="buttonColor">
+			   <property name="cursor">
+				<cursorShape>PointingHandCursor</cursorShape>
+			   </property>
+			   <property name="statusTip">
+				<string>Font color for solution output</string>
+			   </property>
+			   <property name="text">
+				<string>&amp;Color...</string>
+			   </property>
+			   <property name="icon">
+				<iconset resource="../resources/tspsg.qrc">
+				 <normaloff>:/images/icons/color_line.png</normaloff>:/images/icons/color_line.png</iconset>
+			   </property>
+			  </widget>
+			 </item>
+			 <item>
+			  <spacer name="spacer_5">
+			   <property name="orientation">
+				<enum>Qt::Horizontal</enum>
+			   </property>
+			   <property name="sizeHint" stdset="0">
+				<size>
+				 <width>0</width>
+				 <height>0</height>
+				</size>
+			   </property>
+			  </spacer>
+			 </item>
+			</layout>
+		   </widget>
+		  </item>
+		 </layout>
+		</item>
+		<item>
+		 <spacer name="spacer_6">
+		  <property name="orientation">
+		   <enum>Qt::Vertical</enum>
+		  </property>
+		  <property name="sizeHint" stdset="0">
+		   <size>
+			<width>0</width>
+			<height>0</height>
+		   </size>
+		  </property>
+		 </spacer>
+		</item>
+	   </layout>
+	  </widget>
+	 </widget>
+	</item>
    </layout>
   </widget>
@@ -540,12 +466,12 @@
    <slot>accept()</slot>
    <hints>
-    <hint type="sourcelabel">
-     <x>190</x>
-     <y>30</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>306</x>
-     <y>231</y>
-    </hint>
+	<hint type="sourcelabel">
+	 <x>190</x>
+	 <y>30</y>
+	</hint>
+	<hint type="destinationlabel">
+	 <x>306</x>
+	 <y>231</y>
+	</hint>
    </hints>
   </connection>
@@ -556,12 +482,12 @@
    <slot>reject()</slot>
    <hints>
-    <hint type="sourcelabel">
-     <x>190</x>
-     <y>30</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>262</x>
-     <y>245</y>
-    </hint>
+	<hint type="sourcelabel">
+	 <x>190</x>
+	 <y>30</y>
+	</hint>
+	<hint type="destinationlabel">
+	 <x>262</x>
+	 <y>245</y>
+	</hint>
    </hints>
   </connection>
@@ -572,12 +498,12 @@
    <slot>setEnabled(bool)</slot>
    <hints>
-    <hint type="sourcelabel">
-     <x>80</x>
-     <y>150</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>91</x>
-     <y>175</y>
-    </hint>
+	<hint type="sourcelabel">
+	 <x>80</x>
+	 <y>150</y>
+	</hint>
+	<hint type="destinationlabel">
+	 <x>91</x>
+	 <y>175</y>
+	</hint>
    </hints>
   </connection>
@@ -588,12 +514,12 @@
    <slot>setChecked(bool)</slot>
    <hints>
-    <hint type="sourcelabel">
-     <x>80</x>
-     <y>150</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>91</x>
-     <y>175</y>
-    </hint>
+	<hint type="sourcelabel">
+	 <x>80</x>
+	 <y>150</y>
+	</hint>
+	<hint type="destinationlabel">
+	 <x>91</x>
+	 <y>175</y>
+	</hint>
    </hints>
   </connection>
@@ -604,12 +530,12 @@
    <slot>setEnabled(bool)</slot>
    <hints>
-    <hint type="sourcelabel">
-     <x>91</x>
-     <y>175</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>184</x>
-     <y>174</y>
-    </hint>
+	<hint type="sourcelabel">
+	 <x>91</x>
+	 <y>175</y>
+	</hint>
+	<hint type="destinationlabel">
+	 <x>184</x>
+	 <y>174</y>
+	</hint>
    </hints>
   </connection>
